Index: molecuilder/src/Makefile.am
===================================================================
--- molecuilder/src/Makefile.am	(revision 0647f4b96f6476201b602dd6ec2042e3d332e24f)
+++ molecuilder/src/Makefile.am	(revision 401b97b4c52dc316f1eb17c8d8b7ad3dab2ad992)
@@ -1,69 +1,153 @@
+# PLEASE adhere to the alphabetical ordering in this Makefile!
+# Also indentation by a single tab
+
 # this includes source files that need to be present at multiple points
-HELPERSOURCE =  Helpers/Assert.cpp \
-		 		Helpers/MemDebug.cpp
+HELPERSOURCE =  \
+  Helpers/Assert.cpp \
+  Helpers/MemDebug.cpp
 		        
-ATOMSOURCE = atom.cpp atom_atominfo.cpp atom_bondedparticle.cpp atom_bondedparticleinfo.cpp atom_graphnode.cpp atom_graphnodeinfo.cpp atom_particleinfo.cpp atom_trajectoryparticle.cpp atom_trajectoryparticleinfo.cpp
-ATOMHEADER = atom.hpp atom_atominfo.hpp atom_bondedparticle.hpp atom_bondedparticleinfo.hpp atom_graphnode.hpp atom_graphnodeinfo.hpp atom_particleinfo.hpp atom_trajectoryparticle.hpp atom_trajectoryparticleinfo.hpp
-
-LINALGSOURCE = ${HELPERSOURCE} \
-               gslmatrix.cpp \
-			   gslvector.cpp \
-			   linearsystemofequations.cpp \
-			   Space.cpp \
-			   vector.cpp
+ATOMSOURCE = \
+  atom.cpp \
+  atom_atominfo.cpp \
+  atom_bondedparticle.cpp \
+  atom_bondedparticleinfo.cpp \
+  atom_graphnode.cpp \
+  atom_graphnodeinfo.cpp \
+  atom_particleinfo.cpp \
+  atom_trajectoryparticle.cpp \
+  atom_trajectoryparticleinfo.cpp
+ATOMHEADER = \
+  atom.hpp \
+  atom_atominfo.hpp \
+  atom_bondedparticle.hpp \
+  atom_bondedparticleinfo.hpp \
+  atom_graphnode.hpp \
+  atom_graphnodeinfo.hpp \
+  atom_particleinfo.hpp \
+  atom_trajectoryparticle.hpp \
+  atom_trajectoryparticleinfo.hpp
+
+LINALGSOURCE = \
+  ${HELPERSOURCE} \
+  gslmatrix.cpp \
+  gslvector.cpp \
+  linearsystemofequations.cpp \
+  Space.cpp \
+  vector.cpp
 			   
 LINALGHEADER = gslmatrix.hpp \
-			   gslvector.hpp \
-			   linearsystemofequations.hpp \
-			   Space.hpp \
-			   vector.hpp
+  gslvector.hpp \
+  linearsystemofequations.hpp \
+  Space.hpp \
+  vector.hpp
 			   
-
-ANALYSISSOURCE = analysis_bonds.cpp analysis_correlation.cpp
-ANALYSISHEADER = analysis_bonds.hpp analysis_correlation.hpp
+ANALYSISSOURCE = \
+  analysis_bonds.cpp \
+  analysis_correlation.cpp
+ANALYSISHEADER = \
+  analysis_bonds.hpp \
+  analysis_correlation.hpp
 
 ACTIONSSOURCE = Actions/Action.cpp \
-				Actions/ActionHistory.cpp \
-				Actions/ActionRegistry.cpp \
-				Actions/ActionSequence.cpp \
-				Actions/ErrorAction.cpp \
-				Actions/MakroAction.cpp \
-				Actions/ManipulateAtomsProcess.cpp \
-				Actions/MethodAction.cpp \
-                Actions/Process.cpp \
-                Actions/small_actions.cpp
-                
-                 
+  Actions/ActionHistory.cpp \
+  Actions/ActionRegistry.cpp \
+  Actions/ActionSequence.cpp \
+  Actions/ErrorAction.cpp \
+  Actions/MakroAction.cpp \
+  Actions/ManipulateAtomsProcess.cpp \
+  Actions/MethodAction.cpp \
+  Actions/small_actions.cpp \
+  Actions/Process.cpp
+
 ACTIONSHEADER = Actions/Action.hpp \
-				Actions/ActionHistory.hpp \
-				Actions/ActionRegistry.hpp \
-				Actions/ActionSequence.hpp \
- 			    Actions/Calculation.hpp \
- 			    Actions/Calculation_impl.hpp \
- 			    Actions/ErrorAction.hpp \
- 			    Actions/MakroAction.hpp \
- 			    Actions/ManipulateAtomsProcess.hpp \
- 			    Actions/MethodAction.hpp \
- 			    Actions/Process.hpp \
- 			    Actions/small_actions.hpp
- 			    
- 			    
-
-PARSERSOURCE = Parser/ChangeTracker.cpp Parser/FormatParser.cpp Parser/TremoloParser.cpp Parser/XyzParser.cpp
-PARSERHEADER = Parser/ChangeTracker.hpp Parser/FormatParser.hpp Parser/TremoloParser.hpp Parser/XyzParser.hpp
-
-PATTERNSOURCE = Patterns/Observer.cpp
-PATTERNHEADER = Patterns/Cacheable.hpp \
-				Patterns/Observer.hpp \
-                Patterns/Singleton.hpp
-
-VIEWSOURCE = Views/View.cpp Views/StringView.cpp Views/MethodStringView.cpp Views/StreamStringView.cpp
-VIEWHEADER = Views/View.hpp Views/StringView.hpp Views/MethodStringView.hpp Views/StreamStringView.hpp
-
-MENUSOURCE = Menu/Menu.cpp Menu/TextMenu.cpp Menu/MenuItem.cpp Menu/SubMenuItem.cpp Menu/ActionMenuItem.cpp Menu/SeperatorItem.cpp Menu/DisplayMenuItem.cpp
-MENUHEADER = Menu/Menu.hpp Menu/TextMenu.hpp Menu/MenuItem.hpp Menu/SubMenuItem.hpp Menu/ActionMenuItem.hpp Menu/SeperatorItem.hpp Menu/DisplayMenuItem.hpp
-
-UISOURCE = ${ACTIONSSOURCE} ${VIEWSOURCE} ${MENUSOURCE} UIElements/UIFactory.cpp UIElements/TextUIFactory.cpp UIElements/MainWindow.cpp UIElements/TextWindow.cpp UIElements/TextStatusIndicator.cpp UIElements/Dialog.cpp UIElements/TextDialog.cpp
-UIHEADER = ${ACTIONSHEADER} ${VIEWHEADER} ${MENUHEADER} UIElements/UIFactory.hpp UIElements/TextUIFactory.hpp UIElements/MainWindow.hpp UIElements/TextWindow.hpp UIElements/TextStatusIndicator.hpp UIElements/Dialog.hpp UIElements/TextDialog.hpp
+  Actions/ActionHistory.hpp \
+  Actions/ActionRegistry.hpp \
+  Actions/ActionSequence.hpp \
+  Actions/Calculation.hpp \
+  Actions/Calculation_impl.hpp \
+  Actions/ErrorAction.hpp \
+  Actions/MakroAction.hpp \
+  Actions/ManipulateAtomsProcess.hpp \
+  Actions/MethodAction.hpp \
+  Actions/small_actions.hpp \
+  Actions/Process.hpp
+  
+PARSERSOURCE = \
+  Parser/ChangeTracker.cpp \
+  Parser/FormatParser.cpp \
+  Parser/TremoloParser.cpp \
+  Parser/XyzParser.cpp
+PARSERHEADER = \
+  Parser/ChangeTracker.hpp \
+  Parser/FormatParser.hpp \
+  Parser/TremoloParser.hpp \
+  Parser/XyzParser.hpp
+
+PATTERNSOURCE = \
+  Patterns/Observer.cpp
+PATTERNHEADER = \
+  Patterns/Cacheable.hpp \
+  Patterns/Observer.hpp \
+  Patterns/Singleton.hpp
+
+# Below is all for the User Interface
+
+VIEWSOURCE = \
+  Views/View.cpp \
+  Views/StringView.cpp \
+  Views/MethodStringView.cpp \
+  Views/StreamStringView.cpp
+VIEWHEADER = \
+  Views/View.hpp \
+  Views/StringView.hpp \
+  Views/MethodStringView.hpp \
+  Views/StreamStringView.hpp
+
+MENUSOURCE = \
+  Menu/Menu.cpp \
+  Menu/TextMenu.cpp \
+  Menu/MenuItem.cpp \
+  Menu/SubMenuItem.cpp \
+  Menu/ActionMenuItem.cpp \
+  Menu/SeperatorItem.cpp \
+  Menu/DisplayMenuItem.cpp
+  
+MENUHEADER = \
+  Menu/Menu.hpp \
+  Menu/TextMenu.hpp \
+  Menu/MenuItem.hpp \
+  Menu/SubMenuItem.hpp \
+  Menu/ActionMenuItem.hpp \
+  Menu/SeperatorItem.hpp \
+  Menu/DisplayMenuItem.hpp
+
+UISOURCE = \
+  ${ACTIONSSOURCE} \
+  ${MENUSOURCE} \
+  ${TEXTUISOURCE} \
+  ${VIEWSOURCE} \
+  UIElements/Dialog.cpp \
+  UIElements/MainWindow.cpp \
+  UIElements/UIFactory.cpp
+  
+UIHEADER = \
+  ${ACTIONSHEADER} \
+  ${MENUHEADER} \
+  ${TEXTUIHEADER} \
+  ${VIEWHEADER} \
+  UIElements/Dialog.hpp \
+  UIElements/MainWindow.hpp \
+  UIElements/UIFactory.hpp
+
+TEXTUISOURCE = \
+  UIElements/TextDialog.cpp \
+  UIElements/TextStatusIndicator.cpp \
+  UIElements/TextUIFactory.cpp \
+  UIElements/TextWindow.cpp
+TEXTUIHEADER = \
+  UIElements/TextDialog.hpp \
+  UIElements/TextStatusIndicator.hpp \
+  UIElements/TextUIFactory.hpp \
+  UIElements/TextWindow.hpp
 
 # all these files are only used for legacy reasons while the transition is in progress
@@ -74,111 +158,110 @@
 
 DESCRIPTORSOURCE = Descriptors/AtomDescriptor.cpp \
-				   Descriptors/AtomIdDescriptor.cpp \
-				   Descriptors/AtomTypeDescriptor.cpp \
-				   Descriptors/MoleculeDescriptor.cpp \
-				   Descriptors/MoleculeIdDescriptor.cpp 
+  Descriptors/AtomIdDescriptor.cpp \
+  Descriptors/AtomTypeDescriptor.cpp \
+  Descriptors/MoleculeDescriptor.cpp \
+  Descriptors/MoleculeIdDescriptor.cpp 
 				   
 				   
 DESCRIPTORHEADER = Descriptors/AtomDescriptor.hpp \
-				   Descriptors/AtomIdDescriptor.hpp \
-				   Descriptors/AtomTypeDescriptor.hpp \
-				   Descriptors/MoleculeDescriptor.hpp \
-				   Descriptors/MoleculeIdDescriptor.hpp
+  Descriptors/AtomIdDescriptor.hpp \
+  Descriptors/AtomTypeDescriptor.hpp \
+  Descriptors/MoleculeDescriptor.hpp \
+  Descriptors/MoleculeIdDescriptor.hpp
 				   
-
-
 EXCEPTIONSOURCE = Exceptions/CustomException.cpp \
-				  Exceptions/LinearDependenceException.cpp \
-				  Exceptions/MathException.cpp \
-				  Exceptions/ZeroVectorException.cpp
+  Exceptions/LinearDependenceException.cpp \
+  Exceptions/MathException.cpp \
+  Exceptions/ZeroVectorException.cpp
 				  
 EXCEPTIONHEADER = Exceptions/CustomException.hpp \
-				  Exceptions/LinearDependenceException.hpp \
-				  Exceptions/MathException.hpp \
-				  Exceptions/ZeroVectorException.hpp
-
-SOURCE = ${ANALYSISSOURCE} \
-		 ${ATOMSOURCE} \
-		 ${PATTERNSOURCE} \
-		 ${PARSERSOURCE} \
-		 ${UISOURCE} \
-		 ${DESCRIPTORSOURCE} \
-		 ${HELPERSOURCE} \
-		 ${LEGACYSOURCE} \
-		 ${EXCEPTIONSOURCE} \
-		 bond.cpp \
-		 bondgraph.cpp \
-		 boundary.cpp \
-		 config.cpp \
-		 element.cpp \
-		 ellipsoid.cpp \
-		 errorlogger.cpp \
-		 graph.cpp \
-		 helpers.cpp \
-		 info.cpp \
-		 leastsquaremin.cpp \
-		 Line.cpp \
-		 linkedcell.cpp \
-		 lists.cpp \
-		 log.cpp \
-		 logger.cpp \
-		 memoryusageobserver.cpp \
-		 moleculelist.cpp \
-		 molecule.cpp \
-		 molecule_dynamics.cpp \
-		 molecule_fragmentation.cpp \
-		 molecule_geometry.cpp \
-		 molecule_graph.cpp \
-		 molecule_pointcloud.cpp \
-		 parser.cpp \
-		 periodentafel.cpp \
-		 Plane.cpp \
-		 tesselation.cpp \
-		 tesselationhelpers.cpp \
-		 triangleintersectionlist.cpp \
-		 verbose.cpp \
-		 vector_ops.cpp \
-		 World.cpp
+  Exceptions/LinearDependenceException.hpp \
+  Exceptions/MathException.hpp \
+  Exceptions/ZeroVectorException.hpp
+
+SOURCE = \
+  ${ANALYSISSOURCE} \
+  ${ATOMSOURCE} \
+  ${PATTERNSOURCE} \
+  ${PARSERSOURCE} \
+  ${UISOURCE} \
+  ${DESCRIPTORSOURCE} \
+  ${HELPERSOURCE} \
+  ${LEGACYSOURCE} \
+  ${EXCEPTIONSOURCE} \
+  bond.cpp \
+  bondgraph.cpp \
+  boundary.cpp \
+  config.cpp \
+  element.cpp \
+  ellipsoid.cpp \
+  errorlogger.cpp \
+  graph.cpp \
+  helpers.cpp \
+  info.cpp \
+  leastsquaremin.cpp \
+  Line.cpp \
+  linkedcell.cpp \
+  lists.cpp \
+  log.cpp \
+  logger.cpp \
+  memoryusageobserver.cpp \
+  moleculelist.cpp \
+  molecule.cpp \
+  molecule_dynamics.cpp \
+  molecule_fragmentation.cpp \
+  molecule_geometry.cpp \
+  molecule_graph.cpp \
+  molecule_pointcloud.cpp \
+  parser.cpp \
+  periodentafel.cpp \
+  Plane.cpp \
+  tesselation.cpp \
+  tesselationhelpers.cpp \
+  triangleintersectionlist.cpp \
+  verbose.cpp \
+  vector_ops.cpp \
+  World.cpp
 
 HEADER = \
-	  ${ANALYSISHEADER} \
-	  ${ATOMHEADER} \
-	  ${PARSERHEADER} \
-	  ${PATTERNHEADER} \
-	  ${UIHEADER} \
-	  ${DESCRIPTORHEADER} \
-	  ${EXCEPTIONHEADER} \
-	  ${LEGACYHEADER} \
-	  bond.hpp \
-	  bondgraph.hpp \
-	  boundary.hpp \
-	  config.hpp \
-	  defs.hpp \
-	  element.hpp \
-	  ellipsoid.hpp \
-	  errorlogger.hpp \
-	  graph.hpp \
-	  helpers.hpp \
-	  info.hpp \
-	  leastsquaremin.hpp \
-	  Line.hpp \
-	  linkedcell.hpp \
-	  lists.hpp \
-	  log.hpp \
-	  logger.hpp \
-	  memoryallocator.hpp \
-	  memoryusageobserver.hpp \
-	  molecule.hpp \
-	  molecule_template.hpp \
-	  parser.hpp \
-	  periodentafel.hpp \
-	  Plane.hpp \
-	  stackclass.hpp \
-	  tesselation.hpp \
-	  tesselationhelpers.hpp \
-	  triangleintersectionlist.hpp \
-	  verbose.hpp \
-	  vector_ops.hpp \
-	  World.hpp 
+  ${ANALYSISHEADER} \
+  ${ATOMHEADER} \
+  ${PARSERHEADER} \
+  ${PATTERNHEADER} \
+  ${UIHEADER} \
+  ${DESCRIPTORHEADER} \
+  ${EXCEPTIONHEADER} \
+  ${LEGACYHEADER} \
+  bond.hpp \
+  bondgraph.hpp \
+  boundary.hpp \
+  config.hpp \
+  defs.hpp \
+  element.hpp \
+  ellipsoid.hpp \
+  errorlogger.hpp \
+  graph.hpp \
+  helpers.hpp \
+  info.hpp \
+  leastsquaremin.hpp \
+  Line.hpp \
+  linkedcell.hpp \
+  lists.hpp \
+  log.hpp \
+  logger.hpp \
+  memoryallocator.hpp \
+  memoryusageobserver.hpp \
+  molecule.hpp \
+  molecule_template.hpp \
+  parser.hpp \
+  periodentafel.hpp \
+  Plane.hpp \
+  stackclass.hpp \
+  tesselation.hpp \
+  tesselationhelpers.hpp \
+  triangleintersectionlist.hpp \
+  verbose.hpp \
+  vector_ops.hpp \
+  World.hpp 
 
 BOOST_LIB = $(BOOST_LDFLAGS) $(BOOST_MPL_LIB)
@@ -199,6 +282,4 @@
 analyzer_LDADD = libmolecuilder.a $(BOOST_LIB) ${BOOST_THREAD_LIB}
 
-#EXTRA_DIST = ${molecuilder_DATA}
-
 FORCE:
 $(srcdir)/.git-version: FORCE