Index: src/Actions/SelectionAction/AllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/AllAtomsAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
Index: src/Actions/SelectionAction/AllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllMoleculesAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/AllMoleculesAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/AllMoleculesAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
Index: src/Actions/SelectionAction/AtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/AtomByIdAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/AtomByIdAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/AtomByIdAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "log.hpp"
Index: src/Actions/SelectionAction/MoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/MoleculeByIdAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/MoleculeByIdAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/MoleculeByIdAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "molecule.hpp"
 #include "log.hpp"
Index: src/Actions/SelectionAction/NotAllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllAtomsAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/NotAllAtomsAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/NotAllAtomsAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
Index: src/Actions/SelectionAction/NotAllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAllMoleculesAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/NotAllMoleculesAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/NotAllMoleculesAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
Index: src/Actions/SelectionAction/NotAtomByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotAtomByIdAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/NotAtomByIdAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/NotAtomByIdAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "atom.hpp"
 #include "log.hpp"
Index: src/Actions/SelectionAction/NotMoleculeByIdAction.cpp
===================================================================
--- src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision e076cd4f3c751dde2a536163d4fb7f787a2b947e)
+++ src/Actions/SelectionAction/NotMoleculeByIdAction.cpp	(revision 0430e3120648e3906f33481ea1869d1cb3df52a9)
@@ -9,5 +9,5 @@
 
 #include "Actions/SelectionAction/NotMoleculeByIdAction.hpp"
-#include "Actions/ActionCalls.hpp"
+#include "Actions/ActionRegistry.hpp"
 #include "molecule.hpp"
 #include "log.hpp"