Index: src/UIElements/Qt4/InstanceBoard/QtObservedAtom.cpp
===================================================================
--- src/UIElements/Qt4/InstanceBoard/QtObservedAtom.cpp	(revision 08a7eccd3406971777d82560ee81d569921045ec)
+++ src/UIElements/Qt4/InstanceBoard/QtObservedAtom.cpp	(revision 522c456e53a0b038cad5c4e43564052c0e06d8c8)
@@ -101,5 +101,4 @@
   signedOffChannels(0),
   owner(NULL),
-  oldId(_id),
   index(static_cast<const ObservedValue_Index_t>(const_cast<const QtObservedAtom * const>(this))),
   board(_board),
@@ -268,7 +267,5 @@
     case AtomObservable::IndexChanged:
     {
-      const atomId_t newId = getAtomIndex();
-      emit indexChanged(oldId, newId);
-      oldId = newId;
+      emit indexChanged();
       break;
     }
Index: src/UIElements/Qt4/InstanceBoard/QtObservedAtom.hpp
===================================================================
--- src/UIElements/Qt4/InstanceBoard/QtObservedAtom.hpp	(revision 08a7eccd3406971777d82560ee81d569921045ec)
+++ src/UIElements/Qt4/InstanceBoard/QtObservedAtom.hpp	(revision 522c456e53a0b038cad5c4e43564052c0e06d8c8)
@@ -149,5 +149,5 @@
 
 signals:
-  void indexChanged(const atomId_t, const atomId_t);
+  void indexChanged();
   void bondsChanged();
   void elementChanged();
@@ -288,7 +288,4 @@
 
 private:
-  //!> contains still the old id after the index of the atom changed
-  atomId_t oldId;
-
   //!> unique index among all observed instances
   const ObservedValue_Index_t index;
Index: src/UIElements/Qt4/InstanceBoard/QtObservedBond.cpp
===================================================================
--- src/UIElements/Qt4/InstanceBoard/QtObservedBond.cpp	(revision 08a7eccd3406971777d82560ee81d569921045ec)
+++ src/UIElements/Qt4/InstanceBoard/QtObservedBond.cpp	(revision 522c456e53a0b038cad5c4e43564052c0e06d8c8)
@@ -250,11 +250,9 @@
 
   // pass thru to signals from both atoms
-  connect( leftatom.get(), SIGNAL(indexChanged(const atomId_t, const atomId_t)),
-      this, SIGNAL(leftAtomIndexChanged(atomId_t, atomId_t)));
+  connect( leftatom.get(), SIGNAL(indexChanged()), this, SIGNAL(leftAtomIndexChanged()));
   connect( leftatom.get(), SIGNAL(elementChanged()), this, SIGNAL(leftAtomElementChanged()));
   connect( leftatom.get(), SIGNAL(positionChanged()), this, SIGNAL(leftAtomPositionChanged()));
   connect( leftatom.get(), SIGNAL(moleculeChanged()), this, SIGNAL(leftmoleculeChanged()));
-  connect( rightatom.get(), SIGNAL(indexChanged(const atomId_t, const atomId_t)),
-      this, SIGNAL(rightAtomIndexChanged(atomId_t, atomId_t)));
+  connect( rightatom.get(), SIGNAL(indexChanged()), this, SIGNAL(rightAtomIndexChanged()));
   connect( rightatom.get(), SIGNAL(elementChanged()), this, SIGNAL(rightAtomElementChanged()));
   connect( rightatom.get(), SIGNAL(positionChanged()), this, SIGNAL(rightAtomPositionChanged()));
Index: src/UIElements/Qt4/InstanceBoard/QtObservedBond.hpp
===================================================================
--- src/UIElements/Qt4/InstanceBoard/QtObservedBond.hpp	(revision 08a7eccd3406971777d82560ee81d569921045ec)
+++ src/UIElements/Qt4/InstanceBoard/QtObservedBond.hpp	(revision 522c456e53a0b038cad5c4e43564052c0e06d8c8)
@@ -190,11 +190,11 @@
 signals:
 
-  void indexChanged(bondId_t, bondId_t);
+  void indexChanged();
   void degreeChanged();
-  void leftAtomIndexChanged(atomId_t, atomId_t);
+  void leftAtomIndexChanged();
   void leftAtomElementChanged();
   void leftAtomPositionChanged();
   void leftmoleculeChanged();
-  void rightAtomIndexChanged(atomId_t, atomId_t);
+  void rightAtomIndexChanged();
   void rightAtomElementChanged();
   void rightAtomPositionChanged();
Index: src/UIElements/Qt4/InstanceBoard/QtObservedMolecule.cpp
===================================================================
--- src/UIElements/Qt4/InstanceBoard/QtObservedMolecule.cpp	(revision 08a7eccd3406971777d82560ee81d569921045ec)
+++ src/UIElements/Qt4/InstanceBoard/QtObservedMolecule.cpp	(revision 522c456e53a0b038cad5c4e43564052c0e06d8c8)
@@ -109,5 +109,4 @@
   signedOffChannels(0),
   owner(NULL),
-  oldId(_id),
   index(static_cast<const ObservedValue_Index_t>(const_cast<const QtObservedMolecule * const>(this))),
   board(_board),
@@ -276,7 +275,5 @@
         observerLog().addMessage() << "++ Observer " << observerLog().getName(static_cast<Observer *>(this)) << " received notification that atom "+toString(_id)+"'s index has changed.";
   #endif
-        const moleculeId_t newId = getMolIndex();
-        emit indexChanged(oldId, newId);
-        oldId = newId;
+        emit indexChanged();
         break;
       }
Index: src/UIElements/Qt4/InstanceBoard/QtObservedMolecule.hpp
===================================================================
--- src/UIElements/Qt4/InstanceBoard/QtObservedMolecule.hpp	(revision 08a7eccd3406971777d82560ee81d569921045ec)
+++ src/UIElements/Qt4/InstanceBoard/QtObservedMolecule.hpp	(revision 522c456e53a0b038cad5c4e43564052c0e06d8c8)
@@ -160,5 +160,5 @@
   void bondcountChanged();
   void formulaChanged();
-  void indexChanged(const moleculeId_t, const moleculeId_t);
+  void indexChanged();
   void nameChanged();
   void nononhydrogenChanged();
@@ -311,7 +311,4 @@
 
 private:
-  //!> contains still the old index after the index changed
-  moleculeId_t oldId;
-
   //!> unique index among all observed instances
   const ObservedValue_Index_t index;